c     ********************************************************

      subroutine initp_ps(iplanck)

c     called by subroutine disk
c     initialize variables for new photon which scatters in disk
c     for really large envelope, makes approximation of point source.
c     program still set up for emitting from a star, but assume direction
c     is radial.

      implicit none

      real*8 xran,costi,sinti,cospn,phinew,check
      real ran2,atmosfreq,bbfreq
      integer iplanck
      character*20 routine

      include 'tts.txt'
      include 'stokes.txt'
      include 'random.txt'
      
      routine='initp_ps'

c     incident radiation chosen to be unpolarized.
c     can put in a desired polarization in the limb darkening
c     subroutine.
      sip=1.d0
      sqp=0.d0
      sup=0.d0
      svp=0.d0
      
c     sample cosb,sinb, position on star in latitude.
      xran=ran2(i1)
      cosb=1.d0-2.d0*xran
      cosb=check(cosb,routine)
      sinb=dsqrt(1.d0-cosb**2)
      sinb=check(sinb,routine)
      
c     assume direction is same as position.  same as assuming it's
c     a point source.
      cost=cosb
      sint=sinb

c     sample azimuthal coord (longitude)
      xran=ran2(i1)
      lp=r2p*xran

      phi=lp
      sinp=dsin(phi)
      cosp=dcos(phi)
      sinp=check(sinp,routine)
      cosp=check(cosp,routine)

c      print*,'iplanck,iplanckst',iplanck,iplanckst
      if (iplanck.eq.0) then
c         print*,'iplanckst',iplanckst
         if (iplanckst.eq.0) then
           nub=atmosfreq()
         else
           nub=bbfreq(sngl(tstar))
c           print*,'hi,tstar,wave',tstar,1.2398/nub
         endif
      else
         nub=bbfreq(sngl(tshock))
      endif
c      nub=atmosfreq()
c     nub=bbfreq(float(tstar))
c     wave=1.2398/nub

      return
      end
      

c     **********************************************************
