c     *******************************************************
      
      subroutine setup_wave(iwav,cfldust,ctherm,MXWAV)
c     
c     history:
c 00/03/19 (mjw):  set vger position and outside source using
c                      values from parameter file (e.g. REAPAR)
c 00/07/27 (mjw):  fix formatting issue for lf95/gcc (a**-1.5 type)
c 
c     
      
      implicit none
      
      include 'tab.txt'
      include 'tts.txt'
      include 'stokes.txt'
      include 'tabl.txt'
      include 'opacin.txt'
      include 'out.txt'
c     include 'mrncoef.txt'
      include 'random.txt'
      include 'vger.txt'
      include 'taunum.txt'
      include 'dust.com'
      
      integer MXWAV
      character cfldust(MXWAV)*(*),ctherm(MXWAV)*(*)
      
      real*8 a1,c,c1
     1     ,z1cgs,rmincgs,rmindcgs,rmaxdcgs,rddustcgs,p
     1     ,dnoam,hnoam,rnoam,taunoam,c0r2h,xnoam,deltax,deltay,deltaz
     $     ,stot,stot2,roota,rootb,rootc,rootd,t,rvg,fact,rtmp
     1     ,rho1,sigz1,gmax,rmine1,rhodust,tauzdust
     1     ,zmr

      
      real*8 check
      
      integer inoam,iwav,i,id
      logical ifound
      character*20 routine

c	calculate quantities for disk midplane dust properties, id=1
	id=1
      kapd(id)=kappav(id)

      gmax=0.
      do i=1,nlambda(id)
         if (gdust(i,id).gt.gmax) gmax=gdust(i,id)
      enddo
c     peak=1.5*(1.-gmax**2)/(2.+gmax**2)*2./(1.+gmax**2-2.*gmax)**1.5
      
c     for calculating density in cgs
      z1cgs=rstar*rsol*z1
      rmincgs=rstar*rsol
      rmindcgs=rmind*rmincgs
      rmaxdcgs=rmaxd*rmincgs
      rddustcgs=rddust*rmincgs
c     calculate density from massd=mass of disk. 
c     = 2*pi*(integral(density*r*dr*dz)).	
      a1=1.d0-a  
      p=b-a
      
c     scaling factor for computing scattered light in peeled-off image
      sfactor=1.d0/(4.d0*pi)
c     vgfactor=(rstar*rsol)**2
      vgfactor=rstar**2
      
c     11/19/02 BAW, change density formula to Whitney et al. 2002
      if(rmaxd.gt.0.d0) then
c     c stays same
         c=r2p**1.5d0*rmincgs**2*z1cgs
         if(p.ne.-2.and.p.ne.-1.5) then
c     rho=rho0 at r=rmin but mass is integrated from rmind, hence
c            print*,'yo!'
c     print*,massd,msol,c,p,rmaxd,rmind
            rho0=massd*msol/c/
     &           (1./(p+2)*(rmaxd**(p+2)-rmind**(p+2))
     &           -1./(p+1.5)*(rmaxd**(p+1.5)-rmind**(p+1.5)))
c     print*,rho0
c     stop
         else if (p.eq.-2) then
            rho0=massd*msol/c/
     &           (dlog(rmaxd/rmind)
     &           -1./(p+1.5)*(rmaxd**(p+1.5)-rmind**(p+1.5)))
         else if (p.eq.-1.5) then
            rho0=massd*msol/c/
     &           (1./(p+2)*(rmaxd**(p+2)-rmind**(p+2))
     &           -dlog(rmaxd/rmind))
         end if
         write(6,*)'rho0 of disk',rho0
c     opacity in units of rstar**-1 is kappa*rho*rmin.  c0 is multiplier
c     used in radiative transfer.
         c0=kapd(id)*rho0*rmincgs
         c1=kapd(id)*rho0*rmincgs  !for optical depth calcs here
         print*,'kapd',kapd(id)
         if(a.ne.1.0.and.a.ne.0.5) then
            taur=c1/a1*(rmaxd**a1-rddust**a1)
     &         -c1/(0.5d0-a)*(rmaxd**(0.5d0-a)-rddust**(0.5d0-a))
         else if (a.eq.1.0) then
            print*,'hi'
            taur=c1*dlog(rmaxd/rddust)
     &         -c1/(0.5d0-a)*(rmaxd**(0.5d0-a)-rddust**(0.5d0-a))
         else if (a.eq.0.5) then
            taur=c1/a1*(rmaxd**a1-rddust**a1)
     &         -c1*dlog(rmaxd/rddust)
         end if
      else
         c=0.d0
         c0=0.d0
         rho0=0.d0
         taur=0.d0
      end if
      rhod0=rho0
      write(6,*)'c0,c1,taur',c0,c1,taur
c      stop
      if(rmaxd.gt.0.) then
         tauzmin=kapd(id)*dsqrt(r2p)*z1cgs*rho0*rddust**p
     &        *(1.d0-dsqrt(1.d0/rmind))
         tauzdust=kapd(id)*dsqrt(r2p)*z1cgs*rho0*rddust**p
     &        *(1.d0-dsqrt(1.d0/rddust))
         tauzmax=kapd(id)*dsqrt(r2p)*z1cgs*rho0*rmaxd**p
     &        *(1.d0-dsqrt(1.d0/rmaxd))
         tauz30=kapd(id)*dsqrt(r2p)*z1cgs*rho0*(30*autors)**p
     &        *(1.d0-dsqrt(1.d0/(30*autors)))
         write(6,*) 'tauzmin,tauzdust,tauzmax,tauz30'
     &        ,tauzmin,tauzdust,tauzmax,tauz30
c     density at rmind,30AU, rmaxd
         rhomin=rho0*(rmind/rmin)**(-a)*(1.d0-dsqrt(rmin/rmind))
         rhodust=rho0*(rddust/rmin)**(-a)*(1.d0-dsqrt(1.d0/rddust))
         rho30=rho0*(30.d0*autors)**(-a)*
     &        (1.d0-dsqrt(1.d0/(30.d0*autors)))
         rhomax=rho0*(rmaxd/rmin)**(-a)*(1.d0-dsqrt(rmin/rmaxd))
         write(6,*)'density at rmind,rddust,30au,rmaxd',
     &        rhomin,rhodust,rho30,rhomax
         sigz1=dsqrt(r2p)*z1cgs*rho0*(rmind/rmin)**p*
     &        (1.d0-dsqrt(rmin/rmind))
         write(6,*) 'sigma of disk at rmind',sigz1
c     density at 1 AU, sigma at .1 AU
         rho1=rho0*(1.d0*autors/rmin)**(-a)*
     &        (1.d0-dsqrt(1.d0/autors))
         sigz1=dsqrt(r2p)*z1cgs*rho0*(0.1d0*autors)**p*
     &        (1.d0-dsqrt(0.1d0/autors))
         print*,'rho_0, Sigma at 0.1 AU ',rho1,sigz1
c     scale height at 100 AU
        zmr=z1*(100.*autors/rmin)**b
        print*,'h/r at 100 AU ',zmr/autors
c     scale height at rmaxd
        zmr=z1*(rmaxd/rmin)**b
        print*,'h/r at rmaxd/rmaxd ',zmr/rmaxd
      end if
      
c     make a file of disk height and constants vs radius for use with 
c     error function to calculate taus.
c      if(rmaxd.gt.0.d0) then
c         open(unit=14,file='tau.dat',status='unknown')
c         write(14,*)
c     1        'radius (r),scale height (h),c0*r**-a*2h,tau at 3h,F(x1)'
c         dnoam=rmaxd/10.d0
c         do inoam=1,10
c            rnoam=(dfloat(inoam)-0.5d0)*dnoam
c            hnoam=z1*(rnoam/rmin)**b
c            c0r2h=c0*(rnoam/rmin)**(-a)*2.*hnoam*(1.-dsqrt(rmin/rnoam))
c            if(c0.gt.0.) then
c               taunoam=c0r2h*0.0013d0
c               xnoam=1.d0-1.d0/c0r2h
c            end if
c            write(14,*) rnoam,hnoam,c0r2h,taunoam,xnoam
c         end do
c         close(14)
c      end if
      
c     find tau for H=3.5 at rmin
      hnoam=z1*rmind**b
      c0r2h=c0*(rmind)**(-a)*2.*hnoam*(1.-dsqrt(rmin/rmind))
      if(c0.gt.0.) then
         taunoam=c0r2h*0.0002d0
      end if
      write(12,*) 'optical depth to H=3.5 at rmind',taunoam
      print*, 'optical depth to H=3.5 at rmind',taunoam
      
      outillum=1                !for now
c     set vger position in disk
c     if (iveeg.eq.1) then
      if (outillum.eq.0) then
         xvg=1.*autors
         yvg=0.
         hnoam=z1*xvg**b
         zvg=3.44*hnoam
         c0r2h=c0*(xvg)**(-a)*2.*hnoam*(1.d0-dsqrt(1.d0/xvg))
         if(c0.gt.0.) then
            taunoam=c0r2h*0.0003d0
            xnoam=1.d0-1.d0/c0r2h
         end if
         write(12,*) 'vger position, x,y,z ',xvg,yvg,zvg
         write(12,*) 'optical depth from top of disk to vger ',taunoam
      else
c     set position of star emitting outside photons
c     xs=rmax*1.4d0
c     ys=0.0d0*rmax
c     zs=rmax*1.20
         xs=rmax*xsrc0
         ys=rmax*ysrc0
         zs=rmax*zsrc0
         rs=dsqrt(xs**2+ys**2+zs**2)
c     set vger position in outer envelope (for outside illumination)
c     xvg=rmax*0.4d0
c     yvg=0.d0
c     zvg=-rmax*0.2d0
         xvg=rmax*xvg0
         yvg=rmax*yvg0
         zvg=rmax*zvg0
         rvg=dsqrt(xvg**2+yvg**2+zvg**2)
         
c     calculate direction cosines from star to vger
         deltax=xs-xvg
         deltay=ys-yvg
         deltaz=zs-zvg
         stot2=deltax**2+deltay**2+deltaz**2
         stot=dsqrt(stot2)
         cost=deltaz/stot
         cost=check(cost,routine)
         sint=dsqrt(1.-cost**2) !theta ranges from 0-pi so sint>0
         phi=datan2(deltay,deltax)
         if (phi.lt.0) phi=phi+r2p
         cosp=dcos(phi)
         sinp=dsin(phi)      
         ux=sint*cosp
         uy=sint*sinp
c     calculate x,y,z position of direct light from star to 
c     vger once it hits the envelope
         call Rdist(ifound,t,ux,uy,cost,xvg,yvg,zvg,rmax)
         fact=0.9999d0
 333     xse=xvg+ux*t*fact
         yse=yvg+uy*t*fact
         zse=zvg+cost*t*fact
         rpse=dsqrt(xse**2+yse**2)
         rtmp=dsqrt(xse**2+yse**2+zse**2)	 
         if (rtmp.ge.rmax) then
            fact=fact*0.99d0
            go to 333
         endif  
      endif
c     endif
      
      
      if (iwav.eq.1) then
         write(12,*) 'nri,nzi,nfinei',nri,nzi,nfinei
         write(12,*) 'nfined',nfined
         write(12,*) 'infall rate (solar m per yr),ihole',rate,ihole
         write(12,*) 'streamline angle for wind',thetmu0
         write(12,*) 'idust',idust
         write(12,*) 'limb,occult',limb,occult
         write(12,*) 'z=z1*r**b. b = ',b
         write(12,*) 'z1 ',z1
         write(12,*) 'rho(z=0)=c0*r**(-a). a = ',a
         write(12,*) 'c0 ',c0
         write(12,*) 'density at rmind,30AU,rmaxd',rhomin,rho30,rhomax
         write(12,*) 'oa (tan(oa)=zmax/rmaxd)',oadeg
         write(12,*) 'mass in disk, mass of core ',massd,massc
         write(12,*) 'density at midplane of disk, rmin',rho0
      endif
      write(12,*) 'tauzmin,tauz30,tauzmax ',tauzmin,tauz30,tauzmax
      
      
      return
      end
      
