c     ******************************************************

      subroutine testgrid(xp,yp,zp,rsq,rtot,ii,routine,iphot,r2p,uz)

c     test to see if photon position corresponds to grid
c     position, ii(1),ii(2),ii(3)

c     input:
c        xp,yp,zp,rsq  photon position
c        ii(3), grid indices
c        routine, name of subroutine called from
c        iphot, photon number

c     output:
c       ii(3), updated if necessary.

c     ******************************************************

      implicit none

      include 'grid.txt'

      real*8 xp,yp,zp,rsq,beta,lp1,r2p,cosb,rtot,uz
      integer ii(3),ir,it,ip,iphot
      character routine*20
      real*8 check

      ir=ii(1)
      it=ii(2)
      ip=ii(3)

c     print*,'rsq,iphot,r2arr(ir),r2arr(ir+1)'
c     print*,rsq,iphot
c     print*,r2arr(ir)
c     print*,r2arr(ir+1)
c     check
c     rsq should be between r2arr(ir) and r2arr(ir+1)
      if (rsq.lt.r2arr(ir)) then
         if (rsq.lt.r2arr(ir-1)) then
            if (iwarn.eq.1) then
               print*, 'ERROR, rsq way off! ',routine
               print*,'rtot,rarr(ir),ir',rtot,rarr(ir),ir
            endif
            call locate(r2arr,nrg,rsq,ir)
            if (ir.lt.1) then
               if (iwarn.eq.1) then
                  print*,'ERROR testgrid, ir out of limits'
                  print*,'rsq,ir',rsq,ir
               endif
               ir=1
            endif
            if (ir.gt.nrg) then
               if (iwarn.eq.1) then
                  print*,'ERROR testgrid, ir out of limits'
                  print*,'rsq,ir',rsq,ir
               endif
               ir=nrg
            endif
            if (iwarn.eq.1) then
               print*,'new ir',ir
            endif
            ii(1)=ir
         else
            if (iwarn.eq.1) then
               print*,'WARNING, setting ir=ir-1 ',routine
               print*,'iphot,rsq, rsq(ir),rsq(ir+1),ir ',
     $              iphot,rsq,r2arr(ir),r2arr(ir+1),ir
            endif
            ir=ir-1
            ii(1)=ir
         endif
         count_message=count_message+1
      else if (rsq.gt.r2arr(ir+1)) then
         if (rsq.gt.r2arr(ir+2)) then
            if (iwarn.eq.1) then
               print*,'ERROR, rsq way off! too high',routine
               print*,'iphot,rtot,rarr(ir),ir',
     $              iphot,rtot,rarr(ir),ir
            endif
            call locate(r2arr,nrg,rsq,ir)
            if (ir.lt.1) then
               if (iwarn.eq.1) then
                  print*,'ERROR testgrid, ir out of limits'
                  print*,'rsq,ir',rsq,ir
               endif
               ir=1
            endif
            if (ir.gt.nrg) then
               if (iwarn.eq.1) then
                  print*,'ERROR testgrid, ir out of limits'
                  print*,'rsq,ir',rsq,ir
               endif
               ir=nrg
            endif
c     if (ir.lt.1.or.ir.gt.nrg) then
c     print*,'ERROR testgrid, ir out of limits'
c     print*,'rsq,ir',rsq,ir
c     print*,'fatal, stopping'
c     stop
c     endif
            if (iwarn.eq.1) then
               print*,'new ir',ir
            endif
            ii(1)=ir
         else
            if (iwarn.eq.1) then
               print*,'WARNING, setting ir=ir+1',routine
               print*,'iphot,rsq, rsq(ir),rsq(ir+1),ir ',
     $              iphot,rsq,r2arr(ir),r2arr(ir+1),ir
            endif
            ir=ir+1
            ii(1)=ir
         endif
         count_message=count_message+1
      endif

c     beta should be between thetarr(it) and thetarr(it+1)
c     cos(beta) should be between costarr(it) and costarr(it+1)
c     beta=dacos(zp/dsqrt(rsq))
      cosb=zp/rtot
      cosb=check(cosb,routine)
      if (cosb.gt.costarr(it)) then
         count_message=count_message+1
         if (cosb.gt.costarr(it-1)) then
            beta=dacos(cosb)
            if (iwarn.eq.1) then
               print*, 'ERROR, beta way off! ',routine
               print*,'iphot',iphot
               print*,'zp,rtot,cosb,beta,uz',zp,rtot,cosb,beta,uz
               print*,'it,beta,thetarr(it),thetarr(it-1)',
     1              it,beta,thetarr(it),thetarr(it-1) 
               print*,'tan2arr(it),tan2arr(it-1)',
     1              tan2arr(it),tan2arr(it-1)
               count_message=count_message+1
            endif
            call locate(thetarr,ntg,beta,it)
            if (it.lt.1) then
               if (iwarn.eq.1) then
                  print*,'ERROR testgrid, it out of limits'
                  print*,'beta,it',beta,it
               count_message=count_message+1
               endif
               it=1
            endif
            if (it.gt.ntg) then
               if (iwarn.eq.1) then
                  print*,'ERROR testgrid, it out of limits'
                  print*,'beta,it',beta,it
               count_message=count_message+1
               endif
               it=ntg
            endif
            if (iwarn.eq.1) then
               print*,'new it,thet(it) ',it,thetarr(it)
               count_message=count_message+1
            endif
            ii(2)=it
         else
            if (iwarn.eq.1) then
               print*,'WARNING, setting it=it-1 ',routine
               print*,'iphot,cosb,costarr(it),costarr(it-1),it'
               print*,iphot,cosb,costarr(it),costarr(it-1),it
               print*,'r,x,y,z,uz',rtot,xp,yp,zp,uz
               count_message=count_message+1
            endif
            it=it-1
            ii(2)=it
         endif
      else if (cosb.lt.costarr(it+1)) then
         count_message=count_message+1
         if (cosb.lt.costarr(it+2)) then
            cosb=check(cosb,routine)
            beta=dacos(cosb)
            if (iwarn.eq.1) then
               print*,'ERROR, beta way off! ',routine
               print*,'iphot',iphot
               print*,'zp,rtot,cosb,beta,uz',zp,rtot,cosb,beta,uz
               print*,'it,beta,thetarr(it),thetarr(it+1)',
     1              it,beta,thetarr(it),thetarr(it+1) 
               print*,'tan2arr(it),tan2arr(it+1)',
     1              tan2arr(it),tan2arr(it+1)
               count_message=count_message+1
            endif
            call locate(thetarr,ntg,beta,it)
            if (it.lt.1) then
               if (iwarn.eq.1) then
                  print*,'ERROR testgrid, it out of limits'
                  print*,'beta,it',beta,it
               count_message=count_message+1
               endif
               it=1
            endif
            if (it.gt.ntg) then
               if (iwarn.eq.1) then
                  print*,'ERROR testgrid, it out of limits'
                  print*,'beta,it',beta,it
               endif
               it=ntg
            endif
c     if (it.lt.1.or.it.gt.ntg) then
c     print*,'ERROR testgrid, it out of limits'
c     print*,'beta,it',beta,it
c     print*,'fatal, stopping'
c     stop
c     endif
            if (iwarn.eq.1) then
               print*,'new it,thet(it) ',it,thetarr(it)
            endif
            ii(2)=it
         else
            if (iwarn.eq.1) then
               print*,'WARNING, setting it=it+1 ',routine
               print*,'iphot,cosb,costarr(it),costarr(it+1),it'
               print*,iphot,cosb,costarr(it),costarr(it+1),it
               print*,'r,x,y,z,uz',rtot,xp,yp,zp,uz
            endif
            it=it+1
            ii(2)=it
         endif
      endif
      
c     do the same for phi
c     l should be between phiarr(ip) and phiarr(ip+1)
      if (npg.gt.2) then
         lp1=datan2(yp,xp)
         if (lp1.le.0.d0) lp1=lp1+r2p
         if (lp1.lt.phiarr(ip)) then
            count_message=count_message+1
            if (lp1.lt.phiarr(ip-1)) then
               if (iwarn.eq.1) then
                  print*, 'tauint, ERROR, longitude way off! '
               endif
               call locate(phiarr,npg,lp1,ip)
               if (ip.lt.1) then
                  if (iwarn.eq.1) then
                     print*,'ERROR testgrid, ip  out of limits'
                     print*,'lp1,ip',lp1,ip
                  endif
                  ip=1
               endif
               if (ip.gt.npg) then
                  if (iwarn.eq.1) then
                     print*,'ERROR testgrid, ip  out of limits'
                     print*,'lp1,ip',lp1,ip
                  endif
                  ip=npg
               endif
               if (iwarn.eq.1) then
                  print*,'new ip',ip
               endif
               ii(3)=ip
            else
               ip=ip-1
               ii(3)=ip
               if (iwarn.eq.1) then
                  print*,'WARNING, setting ip=ip-1 '
                  print*,'long, phiarr(ip-1),ip-1 ',lp1,
     $                 phiarr(ip),ip
               endif
            endif
         else if (lp1.gt.phiarr(ip+1)) then
            count_message=count_message+1
            if (lp1.gt.phiarr(ip+2)) then
               if (iwarn.eq.1) then
                  print*,'tauint, ERROR, longitude way off! '
               endif
               call locate(phiarr,npg,lp1,ip)
               if (ip.lt.1) then
                  if (iwarn.eq.1) then
                     print*,'ERROR testgrid, ip  out of limits'
                     print*,'lp1,ip',lp1,ip
                  endif
                  ip=1
               endif
               if (ip.gt.npg) then
                  if (iwarn.eq.1) then
                     print*,'ERROR testgrid, ip  out of limits'
                     print*,'lp1,ip',lp1,ip
                  endif
                  ip=npg
               endif
c     if (ip.lt.1.or.ip.gt.npg) then
c     print*,'ERROR testgrid, ip  out of limits'
c     print*,'lp1,ip',lp1,ip
c     print*,'fatal, stopping'
c     stop
c     endif
               if (iwarn.eq.1) then
                  print*,'new ip',ip
               endif
               ii(3)=ip
            else
               ip=ip+1
               ii(3)=ip
               if (iwarn.eq.1) then
                  print*,'WARNING, setting ip=ip+1'
                  print*,'long, phiarr(ip+1),ip+1 ',
     $                 lp1,phiarr(ip),ip
               endif
            endif
         endif
      endif

      return
      end


